{$APPTYPE GUI}

program terminal_demo;

uses
    bearlibterminal;

var
	px, py: integer;
	left, top, right, bottom: integer;
	i, j: integer;
	key: integer;
	temp: string;
	
procedure Move(dx, dy: integer);
begin
    px := px + dx;
    py := py + dy;
    if px < left+1 then px := left+1;
    if py < top+1 then py := top+1;
    if px > right-1 then px := right-1;
    if py > bottom-1 then py := bottom-1;
end;

begin
	{some magic constants}
	left := 1;
    right := 48;
    top := 3;
    bottom := 13;
    px := 3;
    py := 5;

    terminal_open('');
    terminal_font('type=freetype; filename=UbuntuMono-R.ttf; size=14');
    terminal_title('BearLibTerminal: sub-beta demo');
    terminal_size(50, 15);

    terminal_puts(1, 1, 'Something like this?');
    
    while true do begin	
    
		terminal_begin();
        for i:=left to right do begin
			for j:=top to bottom do begin
				if (i = left) or (i = right) or (j = top) or (j = bottom) then begin
					terminal_color(color_from_name('darker gray'));
					terminal_put(i, j, Ord('#'));
				end else if (i = px) and (j = py) then begin
					terminal_color($FFFFFF00); { $AARRGGBB }
					terminal_put(i, j, Ord('@'));
				end else begin
					terminal_put(i, j, 0);
				end;
			end;
		end;
        terminal_end();
        
		key := terminal_get();
		case (key) of
			VK_CLOSE: break;
            VK_LEFT: Move(-1, 0);
            VK_RIGHT: Move(+1, 0);
            VK_UP: Move(0, -1);
            VK_DOWN: Move(0, +1);
        else
            { ?.. }
        end;
        
    end;

    terminal_close();
end.
